/* Copyright Yann Weber <asmsh@yannweb.net>
   This file is part of asmsh.

   asmsh is free software: you can redistribute it and/or modify it under the
   terms of the GNU General Public License as published by the Free Software
   Foundation, either version 3 of the License, or any later version.
   
   asmsh is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
   FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
   details.
   
   You should have received a copy of the GNU General Public License along
   with asmsh. If not, see <https://www.gnu.org/licenses/>.
*/
#ifndef ASMSH_SHELL_CMDS_LIB_H
#define ASMSH_SHELL_CMDS_LIB_H
#include "config.h"

#include "logger.h"
#include "shell_cmds.h"

/** Logs address expression usage */
void asmsh_log_addr_expr_usage();


/** Parse an address expression
 *
 * An expression must be of the form A [OP B] with A and B
 * an integer or '.' for current RIP value and OP one of + or -
 *
 * @param asmsh_cmd_args_t* The breakpoint command argument list
 * @param int The first argument of the address expression
 * @param const unsigned long RIP value
 * @param unsigned long* A pointer on the result address
 *
 * @returns -1 on error and 0 if ok
 */
int asmsh_cmd_parse_addr_expr(asmsh_cmd_args_t *args, int first,
		const unsigned long rip,  unsigned long *addr);

#endif

